/******************************************************************************/
// Program to prepare data from the World Bank Enterprise Surveys (WBS)
//
// Contents:
// SECTION 1: Preliminaries
// SECTION 2: Load data from individual country tabs
// SECTION 3: Carry forward data from one and two previous years as this data source is on a rotating three-year cycle
// 
// Annual update notes:
//	Step 1:  add code for new year at end of SECTION 2 (see note "ADD BLOCKS FOR ADDITIONAL YEARS WITH EACH ANNUAL UPDATE HERE" below)
//	Step 2:  add code for new year at end of SECTION 3 (see note "ADD BLOCKS FOR ADDITIONAL YEARS WITH EACH ANNUAL UPDATE HERE" below)
/******************************************************************************/

/******************************************************************************/
// SECTION 1: Preliminaries
/******************************************************************************/
clear
set more off
// Set input and output file names
global inputfile "$wbs_inputfile"
global outputfile "$wbs_outputfile"
// Initialize dataset with country codes
import excel using "$inputfilepath\\countrycodes.xlsx", firstrow case(lower)
save "$outputfilepath\\$outputfile", replace

/******************************************************************************/
// SECTION 2: Load data from individual country tabs
/******************************************************************************/

// 2023 Data
clear
import excel using "$inputfilepath\\$inputfile", sheet("WGI2023") cellrange(A7:G63) firstrow case(lower) allstring

drop if code==""
drop country
foreach var in pv ge rq rl cc {
	replace wbs23`var'="." if wbs23`var'==".."
	cap destring wbs23`var', replace
}
merge 1:1 code using "$outputfilepath\\$outputfile"
drop _merge
save "$outputfilepath\\$outputfile", replace

// ADD BLOCKS FOR ADDITIONAL YEARS WITH EACH ANNUAL UPDATE HERE

/******************************************************************************/
// SECTION 3: Carry forward data from previous years as this data source covers
// countries on a rotating three-year cycle  [PLACEHOLDER FOR 2025 UPDATE]
/******************************************************************************/